/*
 * slb/tiff.h - Utility functions for the application,
 * when using the shared library.
 *
 * Copyright (C) 2019 Thorsten Otto
 */
#ifndef __SLB_TIFF_H__
#define __SLB_TIFF_H__ 1

#ifndef TIFF_SLB
#define TIFF_SLB 1
#endif

#include <tiffio.h>

#ifndef __CDECL
#define __CDECL
#endif

#include <mint/slb.h>

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

#define TIFF_SHAREDLIB_NAME "tiff.slb"


/*
 * For Pure-C, we still need do redirect some functions
 * that use double arguments and/or return values
 */
#if !defined(__GNUC__)

#if (defined(__68881__) || defined(_M68881) || defined(__M68881__) || defined(__MATH_68881__))

#define TIFFXYZToRGB(cielab, X, Y, Z, r, g, b) TIFF_881_XYZToRGB(cielab, X, Y, Z, r, g, b)

#define slb_tiff_open slb_tiff_open881

#else

#define TIFFXYZToRGB(cielab, X, Y, Z, r, g, b) TIFF_pc_XYZToRGB(cielab, X, Y, Z, r, g, b)

#endif

void TIFF_API TIFFXYZToRGB(TIFFCIELabToRGB *cielab, float X, float Y, float Z, uint32 *r, uint32 *g, uint32 *b);

#endif


long slb_tiff_open(const char *slbpath);
void slb_tiff_close(void);
SLB *slb_tiff_get(void);

/* internal helper function */
long __CDECL tiff_slb_control(long fn, void *arg);

/* Get the full path of the shared library */
#define tiff_slb_libpath() ((const char *)tiff_slb_control(4, 0))


#ifdef __cplusplus
}
#endif

#endif /* __SLB_TIFF_H__ */
